-- ZB_DM_FYWLYBFYDQQB ZB_DM_分业务来源月底前起保保费
-- key:allmonthywlybf/日期
-- 1.	保单的时间口径为： 核保时间在今天并且起保时间的月份小于等于当月。
-- 2.	批单的时间口径为： 核批通过时间在今天并且核批生效时间的月份小于等于当月。


-- step1：
-- 团队汇总
CREATE TEMPORARY VIEW VIEW_ZB_DM_FYWLYBFYDQQB_TUANDUI AS
SELECT
     s1.`uwConclueDate`                    as `uwConclueDate`
    ,s1.`businessNatureCode`               as `businessNatureCode`
    ,s1.`LEVEL1COMCODE`                    as `LEVEL1COMCODE`
    ,s1.`LEVEL2COMCODE`                    as `LEVEL2COMCODE`
    ,s1.`LEVEL3COMCODE`                    as `LEVEL3COMCODE`
    ,s1.`LEVEL4COMCODE`                    as `LEVEL4COMCODE`
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `cost`
from ZB_ODS.ZB_ODS_KAFKA.ZBDATA s1
where
    s1.`COMNAME` is not null
    and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
    -- 起保时间的月份小于等于当月
    and left(s1.`startTime`,6) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyyMM')
group by
    s1.`uwConclueDate`
    ,s1.`businessNatureCode`
    ,s1.`LEVEL1COMCODE`
    ,s1.`LEVEL2COMCODE`
    ,s1.`LEVEL3COMCODE`
    ,s1.`LEVEL4COMCODE`
;



-- 总公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
        'allmonthywlybf/'
        ,s1.`uwConclueDate`
    )                                       as `key`
    ,s1.`businessNatureCode`                as `hkey`
    ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_FYWLYBFYDQQB_TUANDUI s1
group by
    s1.`uwConclueDate`
    ,s1.`businessNatureCode`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
        'provmonthywlybf/'
        ,s1.`uwConclueDate`
        ,'/'
        ,s1.`LEVEL1COMCODE`
    )                                       as `key`
    ,s1.`businessNatureCode`                as `hkey`
    ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_FYWLYBFYDQQB_TUANDUI s1
group by
    s1.`uwConclueDate`
    ,s1.`businessNatureCode`
    ,s1.`LEVEL1COMCODE`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'citymonthywlybf/'
        ,s1.`uwConclueDate`
        ,'/'
        ,s1.`LEVEL2COMCODE`
    )                                        as `key`
     ,s1.`businessNatureCode`                as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_FYWLYBFYDQQB_TUANDUI s1
group by
    s1.`uwConclueDate`
    ,s1.`businessNatureCode`
    ,s1.`LEVEL2COMCODE`
;


-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countrymonthywlybf/'
        ,s1.`uwConclueDate`
        ,'/'
        ,s1.`LEVEL3COMCODE`
     )                                       as `key`
     ,s1.`businessNatureCode`                as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from VIEW_ZB_DM_FYWLYBFYDQQB_TUANDUI s1
group by
    s1.`uwConclueDate`
    ,s1.`businessNatureCode`
    ,s1.`LEVEL3COMCODE`
;


-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teammonthywlybf/'
        ,s1.`uwConclueDate`
        ,'/'
        ,s1.`LEVEL4COMCODE`
     )                                       as `key`
     ,s1.`businessNatureCode`                as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))       as `val`
from VIEW_ZB_DM_FYWLYBFYDQQB_TUANDUI s1
;